diff --git a/src/backend/executor/execExprInterp.c b/src/backend/executor/execExprInterp.c
index 771b7e3945c..e7c2b9fb43c 100644
--- a/src/backend/executor/execExprInterp.c
+++ b/src/backend/executor/execExprInterp.c
@@ -455,9 +455,9 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			 * directly out of the slot's decomposed-data arrays.  But let's
 			 * have an Assert to check that that did happen.
 			 */
-			Assert(attnum >= 0 && attnum < innerslot->tts_nvalid);
-			*op->resvalue = innerslot->tts_values[attnum];
-			*op->resnull = innerslot->tts_isnull[attnum];
+			Assert(attnum >= 0 && attnum < innerslot->nvalid);
+			*op->resvalue = innerslot->values[attnum];
+			*op->resnull = innerslot->nulls[attnum];
 
 			EEO_NEXT();
 		}
@@ -468,9 +468,9 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 
 			/* See EEOP_INNER_VAR comments */
 
-			Assert(attnum >= 0 && attnum < outerslot->tts_nvalid);
-			*op->resvalue = outerslot->tts_values[attnum];
-			*op->resnull = outerslot->tts_isnull[attnum];
+			Assert(attnum >= 0 && attnum < outerslot->nvalid);
+			*op->resvalue = outerslot->values[attnum];
+			*op->resnull = outerslot->nulls[attnum];
 
 			EEO_NEXT();
 		}
@@ -481,9 +481,9 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 
 			/* See EEOP_INNER_VAR comments */
 
-			Assert(attnum >= 0 && attnum < scanslot->tts_nvalid);
-			*op->resvalue = scanslot->tts_values[attnum];
-			*op->resnull = scanslot->tts_isnull[attnum];
+			Assert(attnum >= 0 && attnum < scanslot->nvalid);
+			*op->resvalue = scanslot->values[attnum];
+			*op->resnull = scanslot->nulls[attnum];
 
 			EEO_NEXT();
 		}
@@ -494,12 +494,12 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			Datum		d;
 
 			/* these asserts must match defenses in slot_getattr */
-			Assert(innerslot->tts_tuple != NULL);
-			Assert(innerslot->tts_tuple != &(innerslot->tts_minhdr));
+			//Assert(innerslot->tts_tuple != NULL);
+			//Assert(innerslot->tts_tuple != &(innerslot->tts_minhdr));
 
 			/* heap_getsysattr has sufficient defenses against bad attnums */
-			d = heap_getsysattr(innerslot->tts_tuple, attnum,
-								innerslot->tts_tupleDescriptor,
+			d = heap_getsysattr(((HeapTupleTableSlot *)innerslot)->tuple, attnum,
+								innerslot->tupleDescriptor,
 								op->resnull);
 			*op->resvalue = d;
 
@@ -512,12 +512,12 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			Datum		d;
 
 			/* these asserts must match defenses in slot_getattr */
-			Assert(outerslot->tts_tuple != NULL);
-			Assert(outerslot->tts_tuple != &(outerslot->tts_minhdr));
+			//Assert(outerslot->tts_tuple != NULL);
+			//Assert(outerslot->tts_tuple != &(outerslot->tts_minhdr));
 
 			/* heap_getsysattr has sufficient defenses against bad attnums */
-			d = heap_getsysattr(outerslot->tts_tuple, attnum,
-								outerslot->tts_tupleDescriptor,
+			d = heap_getsysattr(((HeapTupleTableSlot *)outerslot)->tuple, attnum,
+								outerslot->tupleDescriptor,
 								op->resnull);
 			*op->resvalue = d;
 
@@ -530,12 +530,12 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			Datum		d;
 
 			/* these asserts must match defenses in slot_getattr */
-			Assert(scanslot->tts_tuple != NULL);
-			Assert(scanslot->tts_tuple != &(scanslot->tts_minhdr));
+			//Assert(scanslot->tts_tuple != NULL);
+			//Assert(scanslot->tts_tuple != &(scanslot->tts_minhdr));
 
 			/* heap_getsysattr has sufficient defenses against bad attnums */
-			d = heap_getsysattr(scanslot->tts_tuple, attnum,
-								scanslot->tts_tupleDescriptor,
+			d = heap_getsysattr(((HeapTupleTableSlot *)scanslot)->tuple, attnum,
+								scanslot->tupleDescriptor,
 								op->resnull);
 			*op->resvalue = d;
 
@@ -559,9 +559,9 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			 * We do not need CheckVarSlotCompatibility here; that was taken
 			 * care of at compilation time.  But see EEOP_INNER_VAR comments.
 			 */
-			Assert(attnum >= 0 && attnum < innerslot->tts_nvalid);
-			resultslot->tts_values[resultnum] = innerslot->tts_values[attnum];
-			resultslot->tts_isnull[resultnum] = innerslot->tts_isnull[attnum];
+			Assert(attnum >= 0 && attnum < innerslot->nvalid);
+			resultslot->values[resultnum] = innerslot->values[attnum];
+			resultslot->nulls[resultnum] = innerslot->nulls[attnum];
 
 			EEO_NEXT();
 		}
@@ -575,9 +575,9 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			 * We do not need CheckVarSlotCompatibility here; that was taken
 			 * care of at compilation time.  But see EEOP_INNER_VAR comments.
 			 */
-			Assert(attnum >= 0 && attnum < outerslot->tts_nvalid);
-			resultslot->tts_values[resultnum] = outerslot->tts_values[attnum];
-			resultslot->tts_isnull[resultnum] = outerslot->tts_isnull[attnum];
+			Assert(attnum >= 0 && attnum < outerslot->nvalid);
+			resultslot->values[resultnum] = outerslot->values[attnum];
+			resultslot->nulls[resultnum] = outerslot->nulls[attnum];
 
 			EEO_NEXT();
 		}
@@ -591,9 +591,9 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 			 * We do not need CheckVarSlotCompatibility here; that was taken
 			 * care of at compilation time.  But see EEOP_INNER_VAR comments.
 			 */
-			Assert(attnum >= 0 && attnum < scanslot->tts_nvalid);
-			resultslot->tts_values[resultnum] = scanslot->tts_values[attnum];
-			resultslot->tts_isnull[resultnum] = scanslot->tts_isnull[attnum];
+			Assert(attnum >= 0 && attnum < scanslot->nvalid);
+			resultslot->values[resultnum] = scanslot->values[attnum];
+			resultslot->nulls[resultnum] = scanslot->nulls[attnum];
 
 			EEO_NEXT();
 		}
@@ -602,8 +602,8 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 		{
 			int			resultnum = op->d.assign_tmp.resultnum;
 
-			resultslot->tts_values[resultnum] = state->resvalue;
-			resultslot->tts_isnull[resultnum] = state->resnull;
+			resultslot->values[resultnum] = state->resvalue;
+			resultslot->nulls[resultnum] = state->resnull;
 
 			EEO_NEXT();
 		}
@@ -612,12 +612,12 @@ ExecInterpExpr(ExprState *state, ExprContext *econtext, bool *isnull)
 		{
 			int			resultnum = op->d.assign_tmp.resultnum;
 
-			resultslot->tts_isnull[resultnum] = state->resnull;
-			if (!resultslot->tts_isnull[resultnum])
-				resultslot->tts_values[resultnum] =
+			resultslot->nulls[resultnum] = state->resnull;
+			if (!resultslot->nulls[resultnum])
+				resultslot->values[resultnum] =
 					MakeExpandedObjectReadOnlyInternal(state->resvalue);
 			else
-				resultslot->tts_values[resultnum] = state->resvalue;
+				resultslot->values[resultnum] = state->resvalue;
 
 			EEO_NEXT();
 		}
@@ -1897,7 +1897,7 @@ CheckVarSlotCompatibility(TupleTableSlot *slot, int attnum, Oid vartype)
 	 */
 	if (attnum > 0)
 	{
-		TupleDesc	slot_tupdesc = slot->tts_tupleDescriptor;
+		TupleDesc	slot_tupdesc = slot->tupleDescriptor;
 		Form_pg_attribute attr;
 
 		if (attnum > slot_tupdesc->natts)	/* should never happen */
@@ -2050,8 +2050,8 @@ ExecJustAssignInnerVar(ExprState *state, ExprContext *econtext, bool *isnull)
 	 * step explicitly, and we also needn't Assert that the attnum is in range
 	 * --- slot_getattr() will take care of any problems.
 	 */
-	outslot->tts_values[resultnum] =
-		slot_getattr(inslot, attnum, &outslot->tts_isnull[resultnum]);
+	outslot->values[resultnum] =
+		slot_getattr(inslot, attnum, &outslot->nulls[resultnum]);
 	return 0;
 }
 
@@ -2066,8 +2066,8 @@ ExecJustAssignOuterVar(ExprState *state, ExprContext *econtext, bool *isnull)
 	TupleTableSlot *outslot = state->resultslot;
 
 	/* See comments in ExecJustAssignInnerVar */
-	outslot->tts_values[resultnum] =
-		slot_getattr(inslot, attnum, &outslot->tts_isnull[resultnum]);
+	outslot->values[resultnum] =
+		slot_getattr(inslot, attnum, &outslot->nulls[resultnum]);
 	return 0;
 }
 
@@ -2082,8 +2082,8 @@ ExecJustAssignScanVar(ExprState *state, ExprContext *econtext, bool *isnull)
 	TupleTableSlot *outslot = state->resultslot;
 
 	/* See comments in ExecJustAssignInnerVar */
-	outslot->tts_values[resultnum] =
-		slot_getattr(inslot, attnum, &outslot->tts_isnull[resultnum]);
+	outslot->values[resultnum] =
+		slot_getattr(inslot, attnum, &outslot->nulls[resultnum]);
 	return 0;
 }
 
@@ -3858,7 +3858,7 @@ ExecEvalWholeRowVar(ExprState *state, ExprEvalStep *op, ExprContext *econtext)
 			var_tupdesc = lookup_rowtype_tupdesc_domain(variable->vartype,
 														-1, false);
 
-			slot_tupdesc = slot->tts_tupleDescriptor;
+			slot_tupdesc = slot->tupleDescriptor;
 
 			if (var_tupdesc->natts != slot_tupdesc->natts)
 				ereport(ERROR,
@@ -3911,7 +3911,7 @@ ExecEvalWholeRowVar(ExprState *state, ExprEvalStep *op, ExprContext *econtext)
 			 * column names below.
 			 */
 			oldcontext = MemoryContextSwitchTo(econtext->ecxt_per_query_memory);
-			output_tupdesc = CreateTupleDescCopy(slot->tts_tupleDescriptor);
+			output_tupdesc = CreateTupleDescCopy(slot->tupleDescriptor);
 			MemoryContextSwitchTo(oldcontext);
 		}
 
@@ -3963,7 +3963,7 @@ ExecEvalWholeRowVar(ExprState *state, ExprEvalStep *op, ExprContext *econtext)
 	if (op->d.wholerow.slow)
 	{
 		/* Check to see if any dropped attributes are non-null */
-		TupleDesc	tupleDesc = slot->tts_tupleDescriptor;
+		TupleDesc	tupleDesc = slot->tupleDescriptor;
 		TupleDesc	var_tupdesc = op->d.wholerow.tupdesc;
 		int			i;
 
@@ -3976,7 +3976,7 @@ ExecEvalWholeRowVar(ExprState *state, ExprEvalStep *op, ExprContext *econtext)
 
 			if (!vattr->attisdropped)
 				continue;		/* already checked non-dropped cols */
-			if (slot->tts_isnull[i])
+			if (slot->nulls[i])
 				continue;		/* null is always okay */
 			if (vattr->attlen != sattr->attlen ||
 				vattr->attalign != sattr->attalign)
@@ -3993,9 +3993,9 @@ ExecEvalWholeRowVar(ExprState *state, ExprEvalStep *op, ExprContext *econtext)
 	 *
 	 * (Note: it is critical that we not change the slot's state here.)
 	 */
-	tuple = toast_build_flattened_tuple(slot->tts_tupleDescriptor,
-										slot->tts_values,
-										slot->tts_isnull);
+	tuple = toast_build_flattened_tuple(slot->tupleDescriptor,
+										slot->values,
+										slot->nulls);
 	dtuple = tuple->t_data;
 
 	/*
@@ -4099,7 +4099,7 @@ ExecEvalAggOrderedTransTuple(ExprState *state, ExprEvalStep *op,
 	int			setno = op->d.agg_trans.setno;
 
 	ExecClearTuple(pertrans->sortslot);
-	pertrans->sortslot->tts_nvalid = pertrans->numInputs;
+	pertrans->sortslot->nvalid = pertrans->numInputs;
 	ExecStoreVirtualTuple(pertrans->sortslot);
 	tuplesort_puttupleslot(pertrans->sortstates[setno], pertrans->sortslot);
 }
diff --git a/src/backend/executor/execGrouping.c b/src/backend/executor/execGrouping.c
index c4d0e040587..9be9da4b161 100644
--- a/src/backend/executor/execGrouping.c
+++ b/src/backend/executor/execGrouping.c
@@ -202,7 +202,8 @@ BuildTupleHashTable(PlanState *parent,
 	 * We copy the input tuple descriptor just for safety --- we assume all
 	 * input tuples will have equivalent descriptors.
 	 */
-	hashtable->tableslot = MakeSingleTupleTableSlot(CreateTupleDescCopy(inputDesc));
+	hashtable->tableslot = MakeSingleTupleTableSlot(CreateTupleDescCopy(inputDesc),
+													TTS_TYPE_MINIMALTUPLE);
 
 	/* build comparator for all columns */
 	hashtable->tab_eq_func = ExecBuildGroupingEqual(inputDesc, inputDesc,
diff --git a/src/backend/executor/execIndexing.c b/src/backend/executor/execIndexing.c
index 62e51f1ef3b..4403fd7fa3e 100644
--- a/src/backend/executor/execIndexing.c
+++ b/src/backend/executor/execIndexing.c
@@ -706,7 +706,8 @@ check_exclusion_or_unique_constraint(Relation heap, Relation index,
 	 * to this slot.  Be sure to save and restore caller's value for
 	 * scantuple.
 	 */
-	existing_slot = MakeSingleTupleTableSlot(RelationGetDescr(heap));
+	existing_slot = MakeSingleTupleTableSlot(RelationGetDescr(heap),
+											 TTS_TYPE_HEAPTUPLE);
 
 	econtext = GetPerTupleExprContext(estate);
 	save_scantuple = econtext->ecxt_scantuple;
diff --git a/src/backend/executor/execJunk.c b/src/backend/executor/execJunk.c
index 57d74e57c1a..1abc2630b94 100644
--- a/src/backend/executor/execJunk.c
+++ b/src/backend/executor/execJunk.c
@@ -78,7 +78,7 @@ ExecInitJunkFilter(List *targetList, bool hasoid, TupleTableSlot *slot)
 	if (slot)
 		ExecSetSlotDescriptor(slot, cleanTupType);
 	else
-		slot = MakeSingleTupleTableSlot(cleanTupType);
+		slot = MakeSingleTupleTableSlot(cleanTupType, TTS_TYPE_VIRTUAL);
 
 	/*
 	 * Now calculate the mapping between the original tuple's attributes and
@@ -149,7 +149,7 @@ ExecInitJunkFilterConversion(List *targetList,
 	if (slot)
 		ExecSetSlotDescriptor(slot, cleanTupType);
 	else
-		slot = MakeSingleTupleTableSlot(cleanTupType);
+		slot = MakeSingleTupleTableSlot(cleanTupType, TTS_TYPE_VIRTUAL);
 
 	/*
 	 * Calculate the mapping between the original tuple's attributes and the
@@ -275,8 +275,8 @@ ExecFilterJunk(JunkFilter *junkfilter, TupleTableSlot *slot)
 	 * Extract all the values of the old tuple.
 	 */
 	slot_getallattrs(slot);
-	old_values = slot->tts_values;
-	old_isnull = slot->tts_isnull;
+	old_values = slot->values;
+	old_isnull = slot->nulls;
 
 	/*
 	 * get info from the junk filter
@@ -290,8 +290,8 @@ ExecFilterJunk(JunkFilter *junkfilter, TupleTableSlot *slot)
 	 * Prepare to build a virtual result tuple.
 	 */
 	ExecClearTuple(resultSlot);
-	values = resultSlot->tts_values;
-	isnull = resultSlot->tts_isnull;
+	values = resultSlot->values;
+	isnull = resultSlot->nulls;
 
 	/*
 	 * Transpose data into proper fields of the new tuple.
diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index 91ba939bdca..a93cfe963cb 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -1073,7 +1073,7 @@ InitPlan(QueryDesc *queryDesc, int eflags)
 
 			j = ExecInitJunkFilter(planstate->plan->targetlist,
 								   tupType->tdhasoid,
-								   ExecInitExtraTupleSlot(estate, NULL));
+								   ExecInitExtraTupleSlot(estate, NULL, TTS_TYPE_VIRTUAL));
 			estate->es_junkFilter = j;
 
 			/* Want to return the cleaned tuple type */
@@ -2319,7 +2319,7 @@ ExecBuildSlotValueDescription(Oid reloid,
 
 		if (table_perm || column_perm)
 		{
-			if (slot->tts_isnull[i])
+			if (slot->nulls[i])
 				val = "null";
 			else
 			{
@@ -2328,7 +2328,7 @@ ExecBuildSlotValueDescription(Oid reloid,
 
 				getTypeOutputInfo(att->atttypid,
 								  &foutoid, &typisvarlena);
-				val = OidOutputFunctionCall(foutoid, slot->tts_values[i]);
+				val = OidOutputFunctionCall(foutoid, slot->values[i]);
 			}
 
 			if (write_comma)
diff --git a/src/backend/executor/execPartition.c b/src/backend/executor/execPartition.c
index 00523ce250d..04979eb7e75 100644
--- a/src/backend/executor/execPartition.c
+++ b/src/backend/executor/execPartition.c
@@ -93,7 +93,7 @@ ExecSetupPartitionTupleRouting(ModifyTableState *mtstate,
 		 * We need an additional tuple slot for storing transient tuples that
 		 * are converted to the root table descriptor.
 		 */
-		proute->root_tuple_slot = MakeTupleTableSlot(NULL);
+		proute->root_tuple_slot = MakeTupleTableSlot(NULL, TTS_TYPE_HEAPTUPLE);
 	}
 	else
 	{
@@ -112,7 +112,8 @@ ExecSetupPartitionTupleRouting(ModifyTableState *mtstate,
 	 * (such as ModifyTableState) and released when the node finishes
 	 * processing.
 	 */
-	proute->partition_tuple_slot = MakeTupleTableSlot(NULL);
+	proute->partition_tuple_slot = MakeTupleTableSlot(NULL,
+													  TTS_TYPE_HEAPTUPLE);
 
 	i = 0;
 	foreach(cell, leaf_parts)
@@ -590,7 +591,7 @@ get_partition_dispatch_recurse(Relation rel, Relation parent,
 		 * using the correct tuple descriptor when computing its partition key
 		 * for tuple routing.
 		 */
-		pd->tupslot = MakeSingleTupleTableSlot(tupdesc);
+		pd->tupslot = MakeSingleTupleTableSlot(tupdesc, TTS_TYPE_HEAPTUPLE);
 		pd->tupmap = convert_tuples_by_name(RelationGetDescr(parent),
 											tupdesc,
 											gettext_noop("could not convert row type"));
diff --git a/src/backend/executor/execReplication.c b/src/backend/executor/execReplication.c
index 32891abbdf5..daf20589f4f 100644
--- a/src/backend/executor/execReplication.c
+++ b/src/backend/executor/execReplication.c
@@ -92,10 +92,10 @@ build_replindex_scan_key(ScanKey skey, Relation rel, Relation idxrel,
 					pkattno,
 					BTEqualStrategyNumber,
 					regop,
-					searchslot->tts_values[mainattno - 1]);
+					searchslot->values[mainattno - 1]);
 
 		/* Check for null value. */
-		if (searchslot->tts_isnull[mainattno - 1])
+		if (searchslot->nulls[mainattno - 1])
 		{
 			hasnulls = true;
 			skey[attoff].sk_flags |= SK_ISNULL;
@@ -171,7 +171,7 @@ retry:
 		HTSU_Result res;
 		HeapTupleData locktup;
 
-		ItemPointerCopy(&outslot->tts_tuple->t_self, &locktup.t_self);
+		ItemPointerCopy(&((HeapTupleTableSlot *)outslot)->tuple->t_self, &locktup.t_self);
 
 		PushActiveSnapshot(GetLatestSnapshot());
 
@@ -238,7 +238,7 @@ tuple_equals_slot(TupleDesc desc, HeapTuple tup, TupleTableSlot *slot)
 		 * If one value is NULL and other is not, then they are certainly not
 		 * equal
 		 */
-		if (isnull[attrnum] != slot->tts_isnull[attrnum])
+		if (isnull[attrnum] != slot->nulls[attrnum])
 			return false;
 
 		/*
@@ -258,7 +258,7 @@ tuple_equals_slot(TupleDesc desc, HeapTuple tup, TupleTableSlot *slot)
 
 		if (!DatumGetBool(FunctionCall2(&typentry->eq_opr_finfo,
 										values[attrnum],
-										slot->tts_values[attrnum])))
+										slot->values[attrnum])))
 			return false;
 	}
 
@@ -286,7 +286,7 @@ RelationFindReplTupleSeq(Relation rel, LockTupleMode lockmode,
 	bool		found;
 	TupleDesc	desc = RelationGetDescr(rel);
 
-	Assert(equalTupleDescs(desc, outslot->tts_tupleDescriptor));
+	Assert(equalTupleDescs(desc, outslot->tupleDescriptor));
 
 	/* Start a heap scan. */
 	InitDirtySnapshot(snap);
@@ -329,7 +329,7 @@ retry:
 		HTSU_Result res;
 		HeapTupleData locktup;
 
-		ItemPointerCopy(&outslot->tts_tuple->t_self, &locktup.t_self);
+		ItemPointerCopy(&((HeapTupleTableSlot *)outslot)->tuple->t_self, &locktup.t_self);
 
 		PushActiveSnapshot(GetLatestSnapshot());
 
@@ -453,7 +453,7 @@ ExecSimpleRelationUpdate(EState *estate, EPQState *epqstate,
 		resultRelInfo->ri_TrigDesc->trig_update_before_row)
 	{
 		slot = ExecBRUpdateTriggers(estate, epqstate, resultRelInfo,
-									&searchslot->tts_tuple->t_self,
+									&((HeapTupleTableSlot *) searchslot)->tuple->t_self,
 									NULL, slot);
 
 		if (slot == NULL)		/* "do nothing" */
@@ -472,18 +472,18 @@ ExecSimpleRelationUpdate(EState *estate, EPQState *epqstate,
 		tuple = ExecMaterializeSlot(slot);
 
 		/* OK, update the tuple and index entries for it */
-		simple_heap_update(rel, &searchslot->tts_tuple->t_self,
-						   slot->tts_tuple);
+		simple_heap_update(rel, &((HeapTupleTableSlot *) searchslot)->tuple->t_self,
+						   ((HeapTupleTableSlot *)slot)->tuple);
 
 		if (resultRelInfo->ri_NumIndices > 0 &&
-			!HeapTupleIsHeapOnly(slot->tts_tuple))
+			!HeapTupleIsHeapOnly(((HeapTupleTableSlot *)slot)->tuple))
 			recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
 												   estate, false, NULL,
 												   NIL);
 
 		/* AFTER ROW UPDATE Triggers */
 		ExecARUpdateTriggers(estate, resultRelInfo,
-							 &searchslot->tts_tuple->t_self,
+							 &((HeapTupleTableSlot *)searchslot)->tuple->t_self,
 							 NULL, tuple, recheckIndexes, NULL);
 
 		list_free(recheckIndexes);
@@ -514,7 +514,7 @@ ExecSimpleRelationDelete(EState *estate, EPQState *epqstate,
 		resultRelInfo->ri_TrigDesc->trig_delete_before_row)
 	{
 		skip_tuple = !ExecBRDeleteTriggers(estate, epqstate, resultRelInfo,
-										   &searchslot->tts_tuple->t_self,
+										   &((HeapTupleTableSlot *)searchslot)->tuple->t_self,
 										   NULL);
 	}
 
@@ -523,11 +523,11 @@ ExecSimpleRelationDelete(EState *estate, EPQState *epqstate,
 		List	   *recheckIndexes = NIL;
 
 		/* OK, delete the tuple */
-		simple_heap_delete(rel, &searchslot->tts_tuple->t_self);
+		simple_heap_delete(rel, &((HeapTupleTableSlot *)searchslot)->tuple->t_self);
 
 		/* AFTER ROW DELETE Triggers */
 		ExecARDeleteTriggers(estate, resultRelInfo,
-							 &searchslot->tts_tuple->t_self, NULL, NULL);
+							 &((HeapTupleTableSlot *)searchslot)->tuple->t_self, NULL, NULL);
 
 		list_free(recheckIndexes);
 	}
diff --git a/src/backend/executor/execSRF.c b/src/backend/executor/execSRF.c
index b97b8d797ec..163d8bb1183 100644
--- a/src/backend/executor/execSRF.c
+++ b/src/backend/executor/execSRF.c
@@ -509,7 +509,7 @@ restart:
 		 * clearing the slot could end up trying to free something already
 		 * freed.
 		 */
-		oldContext = MemoryContextSwitchTo(slot->tts_mcxt);
+		oldContext = MemoryContextSwitchTo(slot->mcxt);
 		foundTup = tuplestore_gettupleslot(fcache->funcResultStore, true, false,
 										   fcache->funcResultSlot);
 		MemoryContextSwitchTo(oldContext);
@@ -873,7 +873,7 @@ ExecPrepareTuplestoreResult(SetExprState *sexpr,
 			slotDesc = NULL;	/* keep compiler quiet */
 		}
 
-		sexpr->funcResultSlot = MakeSingleTupleTableSlot(slotDesc);
+		sexpr->funcResultSlot = MakeSingleTupleTableSlot(slotDesc, TTS_TYPE_MINIMALTUPLE);
 		MemoryContextSwitchTo(oldcontext);
 	}
 
diff --git a/src/backend/executor/execScan.c b/src/backend/executor/execScan.c
index caf91730ce1..0cc264f2c41 100644
--- a/src/backend/executor/execScan.c
+++ b/src/backend/executor/execScan.c
@@ -235,7 +235,7 @@ void
 ExecAssignScanProjectionInfo(ScanState *node)
 {
 	Scan	   *scan = (Scan *) node->ps.plan;
-	TupleDesc	tupdesc = node->ss_ScanTupleSlot->tts_tupleDescriptor;
+	TupleDesc	tupdesc = node->ss_ScanTupleSlot->tupleDescriptor;
 
 	ExecConditionalAssignProjectionInfo(&node->ps, tupdesc, scan->scanrelid);
 }
@@ -247,7 +247,7 @@ ExecAssignScanProjectionInfo(ScanState *node)
 void
 ExecAssignScanProjectionInfoWithVarno(ScanState *node, Index varno)
 {
-	TupleDesc	tupdesc = node->ss_ScanTupleSlot->tts_tupleDescriptor;
+	TupleDesc	tupdesc = node->ss_ScanTupleSlot->tupleDescriptor;
 
 	ExecConditionalAssignProjectionInfo(&node->ps, tupdesc, varno);
 }
